VERSION 5.00
Begin VB.Form frmEvent 
   Caption         =   "Event Example"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   375
      Left            =   1800
      TabIndex        =   1
      Top             =   2610
      Width           =   1095
   End
   Begin VB.ListBox List1 
      Height          =   2010
      Left            =   90
      TabIndex        =   0
      Top             =   90
      Width           =   4335
   End
End
Attribute VB_Name = "frmEvent"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Event example
' Copyright  1997-2003 by Desaware Inc.

Option Explicit

Private Declare Function CloseEventLog Lib "advapi32.dll" (ByVal hEventLog As Long) As Long
Private Declare Function ReadEventLog Lib "advapi32.dll" Alias "ReadEventLogA" (ByVal hEventLog As Long, ByVal dwReadFlags As Long, ByVal dwRecordOffset As Long, lpBuffer As Byte, ByVal nNumberOfBytesToRead As Long, pnBytesRead As Long, pnMinNumberOfBytesNeeded As Long) As Long
Private Declare Function OpenEventLog Lib "advapi32.dll" Alias "OpenEventLogA" (ByVal lpUNCServerName As String, ByVal lpSourceName As String) As Long
Private Declare Sub RtlMoveMemory Lib "kernel32" (dest As Any, source As Any, ByVal bytes As Long)
Private Declare Function lstrlenptr Lib "kernel32" Alias "lstrlenA" (ByVal lpString As Long) As Long
Private Declare Function lstrcpyfromptr Lib "kernel32" Alias "lstrcpyA" (ByVal lpString1 As String, ByVal lpString2 As Long) As Long

Private Const EVENTLOG_SEQUENTIAL_READ = 1
Private Const EVENTLOG_SEEK_READ = 2
Private Const EVENTLOG_FORWARDS_READ = 4
Private Const EVENTLOG_BACKWARDS_READ = 8
Private Const EVENTLOG_SUCCESS = 0
Private Const EVENTLOG_ERROR_TYPE = 1
Private Const EVENTLOG_WARNING_TYPE = 2
Private Const EVENTLOG_INFORMATION_TYPE = 4
Private Const EVENTLOG_AUDIT_SUCCESS = 8
Private Const EVENTLOG_AUDIT_FAILURE = &H10

Private Type EVENTLOGRECORD
     Length As Long     '  Length of full record
     Reserved As Long     '  Used by the service
     RecordNumber As Long     '  Absolute record number
     TimeGenerated As Long     '  Seconds since 1-1-1970
     TimeWritten As Long     'Seconds since 1-1-1970
     EventID As Long
     EventType As Integer
     NumStrings As Integer
     EventCategory As Integer
     ReservedFlags As Integer     '  For use with paired events (auditing)
     ClosingRecordNumber As Long     'For use with paired events (auditing)
     StringOffset As Long     '  Offset from beginning of record
     UserSidLength As Long
     UserSidOffset As Long
     DataLength As Long
     DataOffset As Long     '  Offset from beginning of record
End Type

Private Const BUFFER_SIZE = 8192  ' Arbitrary number
Dim bBuffer(BUFFER_SIZE) As Byte
Dim dwRead As Long
Dim dwNeeded As Long
Dim cRecords As Long
Dim dwThisRecord As Long

' Get a string given a long pointer
Private Function LoadStringFromPtr(ByVal ptrval&) As String
   Dim slen&
   Dim resstring$
   If ptrval = 0 Then Exit Function
   slen = lstrlenptr(ptrval)
   resstring = String$(slen + 1, 0)
   Call lstrcpyfromptr(resstring, ptrval)
   LoadStringFromPtr = Left$(resstring, slen)
End Function


Private Sub Command1_Click()
   Dim h As Long
   Dim ev As EVENTLOGRECORD
   Dim pevlr As Long
   h = OpenEventLog(vbNullString, "System")
   List1.Clear
   If h <> 0 Then
      pevlr = VarPtr(bBuffer(0))
      While (ReadEventLog(h, EVENTLOG_FORWARDS_READ Or EVENTLOG_SEQUENTIAL_READ, _
            0, bBuffer(0), BUFFER_SIZE, dwRead, dwNeeded) <> 0)
         While dwRead > 0
            ' Copy the data into the ev structure.
            RtlMoveMemory ev, ByVal pevlr, Len(ev)
            List1.AddItem " Event Type: " & Hex$(ev.EventType) & _
                           " Source: " & LoadStringFromPtr(pevlr + Len(ev))
            ' List1.AddItem "Computer name: " & LoadStringFromPtr(pevlr + Len(ev) + lstrlenptr(pevlr + Len(ev)) + 1)
            dwRead = dwRead - ev.Length
            pevlr = pevlr + ev.Length
         Wend
         ' Reset the pointer to the start of the buffer
         pevlr = VarPtr(bBuffer(0))
      Wend
      Call CloseEventLog(h)
   End If
End Sub

