Option Strict On
Option Explicit On
Module PRINFOMOD
    ' Copyright  1996-2004, by Desaware. All Rights Reserved
	
    Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As IntPtr, ByVal nIndex As Integer) As Integer
	
	' Public Constants used in devview
	Public Const DRIVERVERSION As Short = 0
	Public Const TECHNOLOGY As Short = 2
	Public Const HORZSIZE As Short = 4
	Public Const VERTSIZE As Short = 6
	Public Const HORZRES As Short = 8
	Public Const VERTRES As Short = 10
	Public Const BITSPIXEL As Short = 12
	Public Const PLANES As Short = 14
	Public Const NUMBRUSHES As Short = 16
	Public Const NUMPENS As Short = 18
	Public Const NUMMARKERS As Short = 20
	Public Const NUMFONTS As Short = 22
	Public Const NUMCOLORS As Short = 24
	Public Const PDEVICESIZE As Short = 26
	Public Const CURVECAPS As Short = 28
	Public Const LINECAPS As Short = 30
	Public Const POLYGONALCAPS As Short = 32
	Public Const TEXTCAPS As Short = 34
	Public Const CLIPCAPS As Short = 36
	Public Const RASTERCAPS As Short = 38
	Public Const ASPECTX As Short = 40
	Public Const ASPECTY As Short = 42
	Public Const ASPECTXY As Short = 44
	Public Const LOGPIXELSX As Short = 88
	Public Const LOGPIXELSY As Short = 90
	Public Const SIZEPALETTE As Short = 104
	Public Const NUMRESERVED As Short = 106
	Public Const COLORRES As Short = 108
	Public Const PHYSICALWIDTH As Short = 110 '  Physical Width in device units
	Public Const PHYSICALHEIGHT As Short = 111 '  Physical Height in device units
	Public Const PHYSICALOFFSETX As Short = 112 '  Physical Printable Area x margin
	Public Const PHYSICALOFFSETY As Short = 113 '  Physical Printable Area y margin
	Public Const SCALINGFACTORX As Short = 114 '  Scaling factor x
	Public Const SCALINGFACTORY As Short = 115 '  Scaling factor y
	
	Public Const DT_PLOTTER As Short = 0
	Public Const DT_RASDISPLAY As Short = 1
	Public Const DT_RASPRINTER As Short = 2
	Public Const DT_RASCAMERA As Short = 3
	Public Const DT_CHARSTREAM As Short = 4
	Public Const DT_METAFILE As Short = 5
	Public Const DT_DISPFILE As Short = 6
	Public Const CC_NONE As Short = 0
	Public Const CC_CIRCLES As Short = 1
	Public Const CC_PIE As Short = 2
	Public Const CC_CHORD As Short = 4
	Public Const CC_ELLIPSES As Short = 8
	Public Const CC_WIDE As Short = 16
	Public Const CC_STYLED As Short = 32
	Public Const CC_WIDESTYLED As Short = 64
	Public Const CC_INTERIORS As Short = 128
	Public Const LC_NONE As Short = 0
	Public Const LC_POLYLINE As Short = 2
	Public Const LC_MARKER As Short = 4
	Public Const LC_POLYMARKER As Short = 8
	Public Const LC_WIDE As Short = 16
	Public Const LC_STYLED As Short = 32
	Public Const LC_WIDESTYLED As Short = 64
	Public Const LC_INTERIORS As Short = 128
	Public Const PC_NONE As Short = 0
	Public Const PC_POLYGON As Short = 1
	Public Const PC_RECTANGLE As Short = 2
	Public Const PC_WINDPOLYGON As Short = 4
	Public Const PC_TRAPEZOID As Short = 4
	Public Const PC_SCANLINE As Short = 8
	Public Const PC_WIDE As Short = 16
	Public Const PC_STYLED As Short = 32
	Public Const PC_WIDESTYLED As Short = 64
	Public Const PC_INTERIORS As Short = 128
	Public Const CP_NONE As Short = 0
	Public Const CP_RECTANGLE As Short = 1
	Public Const TC_OP_CHARACTER As Short = &H1s
	Public Const TC_OP_STROKE As Short = &H2s
	Public Const TC_CP_STROKE As Short = &H4s
	Public Const TC_CR_90 As Short = &H8s
	Public Const TC_CR_ANY As Short = &H10s
	Public Const TC_SF_X_YINDEP As Short = &H20s
	Public Const TC_SA_DOUBLE As Short = &H40s
	Public Const TC_SA_INTEGER As Short = &H80s
	Public Const TC_SA_CONTIN As Short = &H100s
	Public Const TC_EA_DOUBLE As Short = &H200s
	Public Const TC_IA_ABLE As Short = &H400s
	Public Const TC_UA_ABLE As Short = &H800s
	Public Const TC_SO_ABLE As Short = &H1000s
	Public Const TC_RA_ABLE As Short = &H2000s
	Public Const TC_VA_ABLE As Short = &H4000s
	Public Const TC_RESERVED As Short = &H8000s
	Public Const RC_BITBLT As Short = 1
	Public Const RC_BANDING As Short = 2
	Public Const RC_SCALING As Short = 4
	Public Const RC_BITMAP64 As Short = 8
	Public Const RC_GDI20_OUTPUT As Short = &H10s
	Public Const RC_DI_BITMAP As Short = &H80s
	Public Const RC_PALETTE As Short = &H100s
	Public Const RC_DIBTODEV As Short = &H200s
	Public Const RC_BIGFONT As Short = &H400s
	Public Const RC_STRETCHBLT As Short = &H800s
	Public Const RC_FLOODFILL As Short = &H1000s
	Public Const RC_STRETCHDIB As Short = &H2000s
	Public Const PC_RESERVED As Short = &H1s
	Public Const PC_EXPLICIT As Short = &H2s
	Public Const PC_NOCOLLAPSE As Short = &H4s
End Module