Attribute VB_Name = "PRINFOMOD"
Option Explicit
' Copyright  1996, by Desaware. All Rights Reserved

Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long

' Public Constants used in devview
Public Const DRIVERVERSION = 0
Public Const TECHNOLOGY = 2
Public Const HORZSIZE = 4
Public Const VERTSIZE = 6
Public Const HORZRES = 8
Public Const VERTRES = 10
Public Const BITSPIXEL = 12
Public Const PLANES = 14
Public Const NUMBRUSHES = 16
Public Const NUMPENS = 18
Public Const NUMMARKERS = 20
Public Const NUMFONTS = 22
Public Const NUMCOLORS = 24
Public Const PDEVICESIZE = 26
Public Const CURVECAPS = 28
Public Const LINECAPS = 30
Public Const POLYGONALCAPS = 32
Public Const TEXTCAPS = 34
Public Const CLIPCAPS = 36
Public Const RASTERCAPS = 38
Public Const ASPECTX = 40
Public Const ASPECTY = 42
Public Const ASPECTXY = 44
Public Const LOGPIXELSX = 88
Public Const LOGPIXELSY = 90
Public Const SIZEPALETTE = 104
Public Const NUMRESERVED = 106
Public Const COLORRES = 108
Public Const PHYSICALWIDTH = 110 '  Physical Width in device units
Public Const PHYSICALHEIGHT = 111 '  Physical Height in device units
Public Const PHYSICALOFFSETX = 112 '  Physical Printable Area x margin
Public Const PHYSICALOFFSETY = 113 '  Physical Printable Area y margin
Public Const SCALINGFACTORX = 114 '  Scaling factor x
Public Const SCALINGFACTORY = 115 '  Scaling factor y

Public Const DT_PLOTTER = 0
Public Const DT_RASDISPLAY = 1
Public Const DT_RASPRINTER = 2
Public Const DT_RASCAMERA = 3
Public Const DT_CHARSTREAM = 4
Public Const DT_METAFILE = 5
Public Const DT_DISPFILE = 6
Public Const CC_NONE = 0
Public Const CC_CIRCLES = 1
Public Const CC_PIE = 2
Public Const CC_CHORD = 4
Public Const CC_ELLIPSES = 8
Public Const CC_WIDE = 16
Public Const CC_STYLED = 32
Public Const CC_WIDESTYLED = 64
Public Const CC_INTERIORS = 128
Public Const LC_NONE = 0
Public Const LC_POLYLINE = 2
Public Const LC_MARKER = 4
Public Const LC_POLYMARKER = 8
Public Const LC_WIDE = 16
Public Const LC_STYLED = 32
Public Const LC_WIDESTYLED = 64
Public Const LC_INTERIORS = 128
Public Const PC_NONE = 0
Public Const PC_POLYGON = 1
Public Const PC_RECTANGLE = 2
Public Const PC_WINDPOLYGON = 4
Public Const PC_TRAPEZOID = 4
Public Const PC_SCANLINE = 8
Public Const PC_WIDE = 16
Public Const PC_STYLED = 32
Public Const PC_WIDESTYLED = 64
Public Const PC_INTERIORS = 128
Public Const CP_NONE = 0
Public Const CP_RECTANGLE = 1
Public Const TC_OP_CHARACTER = &H1
Public Const TC_OP_STROKE = &H2
Public Const TC_CP_STROKE = &H4
Public Const TC_CR_90 = &H8
Public Const TC_CR_ANY = &H10
Public Const TC_SF_X_YINDEP = &H20
Public Const TC_SA_DOUBLE = &H40
Public Const TC_SA_INTEGER = &H80
Public Const TC_SA_CONTIN = &H100
Public Const TC_EA_DOUBLE = &H200
Public Const TC_IA_ABLE = &H400
Public Const TC_UA_ABLE = &H800
Public Const TC_SO_ABLE = &H1000
Public Const TC_RA_ABLE = &H2000
Public Const TC_VA_ABLE = &H4000
Public Const TC_RESERVED = &H8000
Public Const RC_BITBLT = 1
Public Const RC_BANDING = 2
Public Const RC_SCALING = 4
Public Const RC_BITMAP64 = 8
Public Const RC_GDI20_OUTPUT = &H10
Public Const RC_DI_BITMAP = &H80
Public Const RC_PALETTE = &H100
Public Const RC_DIBTODEV = &H200
Public Const RC_BIGFONT = &H400
Public Const RC_STRETCHBLT = &H800
Public Const RC_FLOODFILL = &H1000
Public Const RC_STRETCHDIB = &H2000
Public Const PC_RESERVED = &H1
Public Const PC_EXPLICIT = &H2
Public Const PC_NOCOLLAPSE = &H4

